"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var ZirusModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZirusModule = void 0;
const common_1 = require("@nestjs/common");
const cacheManager = require("cache-manager");
const cache_constants_1 = require("./cache.constants");
const default_options_1 = require("./default-options");
let ZirusModule = ZirusModule_1 = class ZirusModule {
    static forRoot(options = {}) {
        return {
            module: ZirusModule_1,
            providers: [
                {
                    provide: cache_constants_1.CACHE_MANAGER,
                    useValue: Array.isArray(options)
                        ? cacheManager.multiCaching(options.map((option) => cacheManager.caching(Object.assign(Object.assign({}, default_options_1.defaultCacheOptions), option))))
                        : cacheManager.caching(Object.assign(Object.assign({}, default_options_1.defaultCacheOptions), options))
                }
            ],
            exports: [cache_constants_1.CACHE_MANAGER]
        };
    }
    static forRootAsync(options) {
        return {
            module: ZirusModule_1,
            imports: options.imports || [],
            providers: [
                {
                    provide: cache_constants_1.CACHE_MANAGER,
                    useFactory: (...args) => {
                        const cacheOptions = options.useFactory(...args);
                        Array.isArray(cacheOptions)
                            ? cacheManager.multiCaching(cacheOptions.map((option) => cacheManager.caching(Object.assign(Object.assign({}, default_options_1.defaultCacheOptions), option))))
                            : cacheManager.caching(Object.assign(Object.assign({}, default_options_1.defaultCacheOptions), cacheOptions));
                    },
                    inject: options.inject || []
                }
            ],
            exports: [cache_constants_1.CACHE_MANAGER]
        };
    }
};
ZirusModule = ZirusModule_1 = __decorate([
    (0, common_1.Global)(),
    (0, common_1.Module)({})
], ZirusModule);
exports.ZirusModule = ZirusModule;
//# sourceMappingURL=zirus.module.js.map